package cn.com.ctop.alarm.modules.controller;

import cn.com.ctop.alarm.modules.entity.RuleIndicator;
import cn.com.ctop.alarm.modules.service.IRuleIndicatorService;
import cn.com.ctop.common.module.annotation.AutoLog;
import cn.com.ctop.common.module.utils.Check;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 规则指标信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-11-14
 */
@Slf4j
@Api(tags = "规则指标信息")
@RestController
@RequestMapping("/ruleIndicator")
public class RuleIndicatorController {
    @Autowired
    private IRuleIndicatorService ruleIndicatorService;


    @AutoLog(value = "规则指标信息-分页列表查询")
    @ApiOperation(value = "规则指标信息-分页列表查询", notes = "规则指标信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<JSONArray> queryPageList(RuleIndicator ruleIndicator) {
        Result<JSONArray> result = new Result<>();
        Integer mediaType = ruleIndicator.getMediaType();
        QueryWrapper<RuleIndicator> queryWrapper = new QueryWrapper();
        queryWrapper.eq("media_type", mediaType);
        queryWrapper.groupBy("dimension");
        List<RuleIndicator> list = ruleIndicatorService.list(queryWrapper);
        JSONArray dataArr = new JSONArray();
        for (RuleIndicator indicator : list) {
            String dimension = indicator.getDimension();
            JSONObject dimensionJson = new JSONObject();
            QueryWrapper<RuleIndicator> queryWrapperData = new QueryWrapper();
            queryWrapperData.eq("media_type", mediaType);
            queryWrapperData.eq("dimension", dimension);
            List<RuleIndicator> dataList = ruleIndicatorService.list(queryWrapperData);
            if (!Check.isNull(dataList)) {
                dimensionJson.put("dimension", dimension);
                // 获取指标名称
                String dimensionName = ruleIndicatorService.getRuleIndicatorNameByMediaTypeAndDimension(mediaType, dimension);
                dimensionJson.put("dimensionName", dimensionName);
                dimensionJson.put("dimensionList", dataList);
                dataArr.add(dimensionJson);
            }
        }
        result.setSuccess(true);
        result.setResult(dataArr);
        return result;
    }

    /**
     * 添加
     *
     * @param ruleIndicator
     * @return
     */
    @AutoLog(value = "规则指标信息-添加")
    @ApiOperation(value = "规则指标信息-添加", notes = "规则指标信息-添加")
    @PostMapping(value = "/add")
    public Result<RuleIndicator> add(@RequestBody RuleIndicator ruleIndicator) {
        Result<RuleIndicator> result = new Result<>();
        try {
            ruleIndicatorService.save(ruleIndicator);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param ruleIndicator
     * @return
     */
    @AutoLog(value = "规则指标信息-编辑")
    @ApiOperation(value = "规则指标信息-编辑", notes = "规则指标信息-编辑")
    @PutMapping(value = "/edit")
    public Result<RuleIndicator> edit(@RequestBody RuleIndicator ruleIndicator) {
        Result<RuleIndicator> result = new Result<RuleIndicator>();
        RuleIndicator ruleIndicatorEntity = ruleIndicatorService.getById(ruleIndicator.getId());
        if (ruleIndicatorEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = ruleIndicatorService.updateById(ruleIndicator);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "规则指标信息-通过id删除")
    @ApiOperation(value = "规则指标信息-通过id删除", notes = "规则指标信息-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            ruleIndicatorService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "规则指标信息-批量删除")
    @ApiOperation(value = "规则指标信息-批量删除", notes = "规则指标信息-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<RuleIndicator> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<RuleIndicator> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.ruleIndicatorService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "规则指标信息-通过id查询")
    @ApiOperation(value = "规则指标信息-通过id查询", notes = "规则指标信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<RuleIndicator> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<RuleIndicator> result = new Result<>();
        RuleIndicator ruleIndicator = ruleIndicatorService.getById(id);
        if (ruleIndicator == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(ruleIndicator);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<RuleIndicator> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                RuleIndicator ruleIndicator = JSON.parseObject(deString, RuleIndicator.class);
                queryWrapper = QueryGenerator.initQueryWrapper(ruleIndicator, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<RuleIndicator> pageList = ruleIndicatorService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "规则指标信息列表");
        mv.addObject(NormalExcelConstants.CLASS, RuleIndicator.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("规则指标信息列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<RuleIndicator> listRuleIndicators = ExcelImportUtil.importExcel(file.getInputStream(), RuleIndicator.class, params);
                ruleIndicatorService.saveBatch(listRuleIndicators);
                return Result.ok("文件导入成功！数据行数:" + listRuleIndicators.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
